package com.sillycycle.bagleyd.welltris;

/*
 * @(#)PolyMode.java
 *
 * Copyright 1993 - 2016  David A. Bagley, bagleyd AT verizon.net
 *
 * Taken from GENERIC X-BASED TETRIS
 *
 * Copyright 1992 - 1995 Q. Alex Zhao, azhao AT cc.gatech.edu
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * The <code>PolyMode</code> class holds the different shape
 * configurations.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/altris.html
 */

public class PolyMode {
	Poly[] poly;
	Mode[] mode;
	int diagonalSwitch;

	public PolyMode(int modes, int types, int nStartPolys, int nPolys,
			int maxUnitsX, int maxUnitsY) {
		poly = new Poly[nPolys];
		for (int i = 0; i < nPolys; i++)
			poly[i] = new Poly(maxUnitsX, maxUnitsY);
		mode = new Mode[modes];
		for (int i = 0; i < modes; i++)
			mode[i] = new Mode(modes, types, nStartPolys);
	}

	public PolyMode(int i, int j) {
		poly = new Poly[i];
		mode = new Mode[j];
	}
}

class Poly {
	int     rotation;
	int     reflection;
	int[]   startHeight;
	int[][] shape;
	int     size;

	int lc, cc;
	char c;

	public Poly(int x, int y) {
		shape = new int[y][x];
		startHeight = new int[2];
	}
}

class Mode {
	int[][] number;
	int[][] start;
	int turnStyle;

	public Mode(int modes, int types, int startPoly) {
		number = new int [modes][types];
		start  = new int [startPoly][types];
	}
}
